﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KB5944_SampleApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();

            // UseOsThemesを無効にする。
            ultraGrid1.UseOsThemes = Infragistics.Win.DefaultableBoolean.False;
        }

        private DataTable GetData()
        {
            DataTable dt = new DataTable();

            // Columns
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("Col1", typeof(String));

            // Rows
            for(int i = 0; i < 5; i++)
            {
                dt.Rows.Add(new object[] { i, "Row " + i.ToString() + ", Col 1" });
            }

            // Primary key
            dt.PrimaryKey = new DataColumn[] { dt.Columns["ID"] };


            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridColumn buttonColumn = e.Layout.Bands[0].Columns.Add("ButtonColumn", "Button Column");
            buttonColumn.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            buttonColumn.ButtonDisplayStyle = ButtonDisplayStyle.Always;

            // 背景色黄色、文字色黒のAppearanceオブジェクトが未作成の場合は、新規作成し、DisplayLayoutに追加しておく。
            if (false == e.Layout.Appearances.Exists("Yellow"))
            {
                Infragistics.Win.Appearance yellowAppearance = e.Layout.Appearances.Add("Yellow");
                yellowAppearance.ThemedElementAlpha = Infragistics.Win.Alpha.Transparent;
                yellowAppearance.BackColor = Color.Yellow;
                yellowAppearance.ForeColor = Color.Black;
            }
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells["ButtonColumn"].Value = "Click Here";

            // 背景色を黄色、文字色を黒にするAppearanceを適用する。
            e.Row.Cells["ButtonColumn"].ButtonAppearance = e.Row.Band.Layout.Appearances["Yellow"];
        }
    }
}
